Loading...
Searching...
No Matches
LeafData< Point, CoordT, MaskT, LOG2DIM > Struct Template Reference

`#include <nanovdb/NanoVDB.h>`

## Public Types

using | ValueType = uint64_t
using | BuildType = Point
using | FloatType = typename FloatTraits<ValueType>::FloatType
using | ArrayType = uint16_t

## Public Member Functions

uint64_t | offset () const
uint64_t | pointCount () const
uint64_t | first (uint32_t i) const
uint64_t | last (uint32_t i) const
uint64_t | getValue (uint32_t i) const
void | setValueOnly (uint32_t offset, uint16_t value)
void | setValue (uint32_t offset, uint16_t value)
void | setOn (uint32_t offset)
ValueType | getMin () const
ValueType | getMax () const
FloatType | getAvg () const
FloatType | getDev () const
void | setMin (const ValueType &)
void | setMax (const ValueType &)
void | setAvg (const FloatType &)
void | setDev (const FloatType &)
template<typename T>
void | setOrigin (const T &ijk)
| LeafData ()=delete
| This class cannot be constructed or deleted.
| LeafData (const LeafData &)=delete
LeafData & | operator= (const LeafData &)=delete
| ~LeafData ()=delete
void | fill (const ValueType &v)

## Static Public Member Functions

static constexpr uint32_t | padding ()
| Return padding of this class in bytes, due to aliasing and 32B alignment.
static uint64_t | memUsage ()
static bool | hasStats ()

## Public Attributes

CoordT | mBBoxMin
uint8_t | mBBoxDif [3]
uint8_t | mFlags
MaskT< LOG2DIM > | mValueMask
uint64_t | mOffset
uint64_t | mPointCount
uint16_t | mValues [1u<< 3 *LOG2DIM]
ValueType | mMinimum
ValueType | mMaximum
FloatType | mAverage
FloatType | mStdDevi

## Static Public Attributes

static constexpr bool | FIXED_SIZE = true

## Member Typedef Documentation

## ArrayType

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using ArrayType = uint16_t

## BuildType

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using BuildType = Point

## FloatType

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using FloatType = typename FloatTraits<ValueType>::FloatType

## ValueType

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

using ValueType = uint64_t

## Constructor & Destructor Documentation

## LeafData() [1/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( |  | ) |

delete

This class cannot be constructed or deleted.

## LeafData() [2/2]

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData | ( | const LeafData< Point, CoordT, MaskT, LOG2DIM > & |  | ) |

delete

## ~LeafData()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

~LeafData | ( |  | ) |

delete

## Member Function Documentation

## fill()

void fill | ( | const ValueType & | v | ) |

inline

## first()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t first | ( | uint32_t | i | ) | const

inline

## getAvg()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

FloatType getAvg | ( |  | ) | const

inline

## getDev()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

FloatType getDev | ( |  | ) | const

inline

## getMax()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

ValueType getMax | ( |  | ) | const

inline

## getMin()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

ValueType getMin | ( |  | ) | const

inline

## getValue()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t getValue | ( | uint32_t | i | ) | const

inline

## hasStats()

bool hasStats | ( |  | ) |

inlinestatic

## last()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t last | ( | uint32_t | i | ) | const

inline

## memUsage()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t memUsage | ( |  | ) |

inlinestatic

## offset()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t offset | ( |  | ) | const

inline

## operator=()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

LeafData & operator= | ( | const LeafData< Point, CoordT, MaskT, LOG2DIM > & |  | ) |

delete

## padding()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

constexpr uint32_t padding | ( |  | ) |

inlinestaticconstexpr

Return padding of this class in bytes, due to aliasing and 32B alignment.

Note
  The extra bytes are not necessarily at the end, but can come from aliasing of individual data members.

## pointCount()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t pointCount | ( |  | ) | const

inline

## setAvg()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setAvg | ( | const FloatType & |  | ) |

inline

## setDev()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setDev | ( | const FloatType & |  | ) |

inline

## setMax()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMax | ( | const ValueType & |  | ) |

inline

## setMin()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setMin | ( | const ValueType & |  | ) |

inline

## setOn()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setOn | ( | uint32_t | offset | ) |

inline

## setOrigin()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>
template<typename T>

void setOrigin | ( | const T & | ijk | ) |

inline

## setValue()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setValue | ( | uint32_t | offset,
|  | uint16_t | value )

inline

## setValueOnly()

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

void setValueOnly | ( | uint32_t | offset,
|  | uint16_t | value )

inline

## Member Data Documentation

## FIXED_SIZE

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

bool FIXED_SIZE = true

staticconstexpr

## mAverage

FloatType mAverage

## mBBoxDif

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t mBBoxDif[3]

## mBBoxMin

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

CoordT mBBoxMin

## mFlags

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint8_t mFlags

## mMaximum

ValueType mMaximum

## mMinimum

ValueType mMinimum

## mOffset

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t mOffset

## mPointCount

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint64_t mPointCount

## mStdDevi

FloatType mStdDevi

## mValueMask

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

MaskT<LOG2DIM> mValueMask

## mValues

template<typename CoordT, template< uint32_t > class MaskT, uint32_t LOG2DIM>

uint16_t mValues[1u<< 3 *LOG2DIM]